unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Buttons;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    procedure EintraegeVerschieben(QuellListbox, ZielListbox: TListbox);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.EintraegeVerschieben(QuellListbox, ZielListbox: TListbox);
var
  i: Integer;
begin
  // Alle Einträge der Quell-Listbox durchgehen. Wenn ein Eintrag ausgewählt ist
  // QuellListbox.Selected(index), den String in der Ziellistbox anhängen.
  for i := 0 to QuellListbox.Items.Count-1 do
    if QuellListbox.Selected[i] then
      ZielListbox.Items.Add(QuellListbox.Items[i]);
  
  // Nun nochmals die Einträge der Quelllistbox durchgehen und die markierten
  // Einträge löschen. ACHTUNG: von oben nach unten durchlaufen, weil sich beim
  // Löschen die Nummerierung der Einträge ändert.
  for i := QuellListbox.Items.Count-1 downto 0 do
    if QuellListbox.Selected[i] then
      QuellListbox.Items.Delete(i);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  EintraegeVerschieben(Listbox1, Listbox2);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  EintraegeVerschieben(Listbox2, Listbox1);
end;


end.

